;;; -*- Syntax: Common-Lisp; Package: QSIM -*-

(in-package 'QSIM)

(defun describe-ignore-qdirs ()
  (format *qsim-report*
"~2%Ignore-Qdirs is used to ignore irrelevant distinction of behaviors arising
from the `chattering' phenomenon.  This phenomenon arises when the direction
of change of a parameter is unconstrained.  For example, if NET = IN - OUT
with both IN and OUT increasing, the next important qualitative change is
when NET reaches 0.  However, in the mean time, NET can change from increasing
to steady to decreasing arbitrarily many times, leading to a branch for each
possibility.  To ignore irrelevant distinctions in this case, include the
subclause:  (IGNORE-QDIRS NET) in the Other clause in the QDE.

Using Ignore-Qdirs amounts to adopting a coarser grain model of a system.
Ignored distinctions many have been genuine or they may have been spurious.
See Curvature-Constraints for a way to deal with spurious `chattering'."))