;;; -*- Mode: Common-lisp; Package: qsim; Base: 10 -*-
;;;  $Id: defothers.lisp,v 1.10 92/07/01 17:28:49 clancy Exp $

(in-package :qsim) ;changed DJC

(defother qde chattering-variables)		; User assert chattering variables for QDE.
(defother qde derived-chvars)			; Merge w results of automatic identification.
(defother qde derived-chvar-classes)		; Equivalence classes of chattering vars.
(defother qde curvature-at-steady)		; Alist of (<var> <sd2-exp>).
(defother qde derived-sd2-expressions)		; Derived alist of (<var> <sd2-exp>).
(defother qde sd3-constraint)     		; Alist of (<var> <sd3-exp>).
(defother qde context)				; Used only in cast.lisp.
(defother qde qspaces1)				; Used only in cast.lisp.
(defother qde M-envelopes)			; Q2 envelopes on M+/M- constraints.
(defother qde energy-constraint)		; Energy constraint used in energy-gf.lisp.
(defother qde derived-energy-constraint)	; Holds automatically derived KET constraint.
(defother qde define-normal)			; Used by tsa.
(defother qde lmarks-alist)			; Temporary storage used while building shared
						;  quantity spaces.
(defother qde functions)			; Specifications of named monotonic functions
(defother qde states)				; To perform envisionment

(defother qval  event-p)

(defother state twins)				; List of "similar" sibling states..
(defother state event-count)			
(defother state assert-ranges)			; User-asserted quantitative ranges.
(defother state eqn-index)			; Q2 equations among landmarks.
(defother state bindings)			; Q2 intervals on landmarks.
(defother state display-block)                  ; records information for qsim-display.
(defother state new-successors)			; Used in aggregation algorithms, see
(defother state new-predecessors)		; the definition of the structure Levels
(defother state levels)				; for details
(defother state sim)				; Pointer to the SIM used to create the state.
(defother state aggregates)                     ; Used in the elimination of occurrence branching@
(defother state stability-test)			; store its stability test in a state.


						
(defother contype equivfcn)

(defother constraint partials)			; signs of partials in M constraint

(defother display-block basic-level)		; Pointer to the basic level.
(defother display-block levels)			; List of already defined levels.
(defother display-block envisionment-p)		; Whether it's an envisionment graph or
						; a behavior tree.
(defother display-block plot-intervals)		; Flag to control the display of
						; intervals.
(defother display-block truncate?)              ; Contains a time qmag.  If one is specified, then
                                                ; it will cause behaviors to be
						; truncated at this time point.

(defother sim envisionment-p)			; T if envisioning
(defother sim states)				; List of states created
(defother sim -temp-susp-agenda)                ; Keeps a list of states which have been temporarily
                                                ; suspended from the agenda.


